import re
import range
from gnuplot import Gnuplot
import window

class Appearances(window.Window):
	def __init__(self):
		window.Window.__init__(self, "appearances")
		
		gp = Gnuplot()
		gp.show("margin")
		data = gp.get_last_event()
	
	## Tab 1
		margins = re.findall("[\s]+([lbrt])margin is (.+)", data)
		for margin in margins:
			if margin[1] == "computed automatically":
				value = -1
			else:
				match = re.search("set to (screen)? ?(.+)", margin[1]).groups()
				value = float(match[1])
				if match[0]: self.child("chk_%smargin" % margin[0]).set_active(True)
			self.child("spb_%smargin" % margin[0]).set_value(value)
	
		gp.show("size")
		data = gp.get_last_event()
		
		x,y = re.search("size is scaled by (.+),(.+)", data).groups()
		self.child("spb_xscale").set_value(float(x))
		self.child("spb_yscale").set_value(float(y))
		
		match = re.search("set (LOCKED)? ?aspect ratio to (.+):1.0", data)
		if match:
			value = float(match.group(2))
			if match.group(1): value = -value
			if value == 1.0:
				self.child("rdo_square").set_active(True)
			else:
				self.child("rdo_ratio").set_active(True)
				self.child("spb_ratio").set_value(value)
		else:
			self.child("rdo_none").set_active(True)

	def on_cmd_cancel_clicked(self, widget, data = None):
		self.window.destroy()

	def on_cmd_apply_clicked(self, widget, data = None):
		gp = Gnuplot()
		
	### Tab 1: Margins and size
		margins = ('l', 't', 'b', 'r')
		
		for m in margins:
			gp.set_margin(m, self.child("spb_%smargin" % m).get_value(), self.child("chk_%smargin" % m).get_active())
		
		x = self.child("spb_xscale").get_value()
		y = self.child("spb_yscale").get_value()
		
		ratio = None
		if self.child("rdo_square").get_active(): ratio = 1
		elif self.child("rdo_ratio").get_active(): ratio = self.child("spb_ratio").get_value()
		gp.set_size(x, y, ratio)
		
		gp.replot()
		
	def on_cmd_ok_clicked(self, widget, data = None):
		self.on_cmd_apply_clicked(widget, data)
		self.on_cmd_cancel_clicked(widget, data)

	def on_rdo_ratio_toggled(self, widget, data = None):
		self.child("spb_ratio").set_sensitive(widget.get_active())
