import re
import gtk
import range
from gnuplot import Gnuplot
import dialog

class Colorspec(dialog.Dialog):
	def __init__(self):
		dialog.Dialog.__init__(self, "colorspec")
		
		self.window.add_buttons(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OK, gtk.RESPONSE_OK)
		
		gp = Gnuplot()
		gp.show("colornames")
		
		colors = re.findall('[\s]*(.+?)[\s]*?[#]([0-9a-fA-F]+)', gp.get_last_event())
		
		m = self.child("ls_named_color")
		for color in colors: m.append(color)
		
		self.on_rdo_frac_toggled(self.child("rdo_frac"))
		
	def get_color(self):
		if self.child("rdo_rgb").get_active():
			m = self.child("ls_named_color")
			widget = self.child("cbo_named_color")
			try:
				named_color = '#' + m.get_value(widget.get_active_iter(), 1)
			except TypeError:
				named_color = ""
			color = self.child("cs_rgb").get_current_color()
			current_color = '#%02x%02x%02x' % (color.red % 256, color.green % 256, color.blue % 256)
			if named_color.lower() == current_color.lower():
				color_name = m.get_value(widget.get_active_iter(), 0)
			else:
				color_name = current_color
			return 'rgb "%s"' % color_name
		else:
			return 'palette %s %s' % ("cb" if self.child("rdo_abs").get_active() else "frac",
			                                                      str(self.child("spb_palette").get_value()))
				
	
	def on_rdo_palette_toggled(self, widget, data = None):
		state = widget.get_active()
		self.child("cs_rgb").set_sensitive(not state)
		self.child("hb_palette").set_sensitive(state)
	
	def on_rdo_frac_toggled(self, widget, data = None):
		adj = self.child("adj_lc_palette")
		
		if widget.get_active():
			adj.set_upper(1)
			adj.set_lower(0)
		else:
			cb = range.Range("cb")
			adj.set_upper(cb.upper)
			adj.set_lower(cb.lower)
	
	def on_cbo_named_color_changed(self, widget, data = None):
		color = widget.get_model().get_value(widget.get_active_iter(), 1)
		
		self.child("cs_rgb").set_current_color(gtk.gdk.Color('#%s' % color))
