import gtk
import os
import os.path
import ConfigParser

class Config(ConfigParser.ConfigParser):
	
	sections = (
		'General',
		'Command_line'
	)
	
	keys = {
		'startup_conf_file' : ("General", "fc_general_startup_conf_file", "filename"), # Check
		'replot_at_cmd' : ("Command_line", "chk_command_line_replot_at_cmd", "active"), # Check
		'add_from_cmd_line' : ("Command_line", "chk_command_line_add_from_cmd_line", "active"), # Check
		'filter_history' : ("Command_line", "chk_command_line_filter_history", "active"), # Check
		'max_history' : ("Command_line", "spb_command_line_max_history", "value") # Check
	}

	levels = {
		0 : ('startup_conf_file',
		     'replot_at_cmd',
		     'add_from_cmd_line',
		     'filter_history',
		     'max_history')
	}

	defaults = {
		'startup_conf_file' : "None",
		'replot_at_cmd' : "True",
		'add_from_cmd_line' : "True",
		'filter_history' : "True",
		'max_history' : "-1"
	}
	
	__shared_state = {
		'sections' : sections,
		'keys' : keys,
		'levels' : levels,
		'config_file' : os.path.expanduser('~/.pygtkplot/config'),
		'defaults' : defaults
	}

	def __init__(self):
		self.__dict__ = self.__shared_state
		ConfigParser.RawConfigParser.__init__(self, self.defaults)

	def load_level(self, num = 0):
		try:
			with open(self.config_file, 'r') as f:
				self.readfp(f)
				for key in self.levels[num]:
					try:
						exec("self.%s = self.get('%s','%s')" % (key, self.keys[key][0], key))
					except (ConfigParser.NoOptionError, ConfigParser.NoSectionError):
						setattr(self, key, self.defaults[key])
		except IOError:
			self.__dict__.update(self.defaults)

	def save_level(self, num = 0):
		for section in self. sections:
			try:
				self.add_section(section)
			except:
				pass
				
		if not os.path.isdir(os.path.expanduser(r'~/.pygtkplot/')):
			os.mkdir(os.path.expanduser('~/.pygtkplot/'))
			
		with open(self.config_file, 'w') as f:
			for key in self.levels[num]:
				self.set(self.keys[key][0], key, getattr(self, key))
			self.write(f)

	def sync_to_ui(self, window):
		for num in list(self.levels):
			for key in self.levels[num]:
				try:
					exec("if self.%s != 'None': window.child('%s').set_%s(%s)" % (key, self.keys[key][1], self.keys[key][2], eval("self.%s" % key)))
				except (SyntaxError, TypeError): # Dummy Exception. Must be fixed
					exec("if self.%s != 'None': window.child('%s').set_%s('%s')" % (key, self.keys[key][1], self.keys[key][2], eval("self.%s" % key)))

	def sync_from_ui(self, window):
		for num in list(self.levels):
			for key in self.levels[num]:
				try:
					exec("self.%s = str(window.child('%s').get_%s())" % (key, self.keys[key][1], self.keys[key][2]))
				except IOError: # Dummy Exception. Must be fixed
					pass
