import window
from sympy import *

class Conformal(window.Window):
	def __init__(self, main):
		self.main = main
		window.Window.__init__(self, "conformal")

	def on_cmd_cancel_clicked(self, widget, data = None):
		self.window.destroy()
		
	def on_cmd_ok_clicked(self, widget, data = None):
		formula = self.child("txt_formula").get_text()
		z = Symbol("z")
		exec("a = (%s).as_real_imag()" % formula)
		if self.child("rdo_polar").get_active():
			re = str(a[0]).replace("im(z)", "u*sin(v)").replace("re(z)", "u*cos(v)")
			im = str(a[1]).replace("im(z)", "u*sin(v)").replace("re(z)", "u*cos(v)")
		else:
			re = str(a[0]).replace("im(z)", "v").replace("re(z)", "u")
			im = str(a[1]).replace("im(z)", "v").replace("re(z)", "u")
		self.main.child("txt_function").set_text("%s, %s, sqrt(u**2 + v**2)" % (re, im))
		self.main.child("txt_title").set_text(eval("latex(%s)" % formula))
		self.main.child("chk_parametric").set_active(True)
		self.main.child("rdo_surface").set_active(True)
		self.on_cmd_cancel_clicked(widget, data)
