import gtk

class Dialog():
	def __init__(self, win_name):
		builder = gtk.Builder()
		self.builder = builder
		builder.add_from_file("%s.glade" % win_name)
		self.window = builder.get_object(win_name)
		builder.connect_signals(self)

	def set_title(self, title):
		self.window.set_title(title)

	def run(self):
		return self.window.run()

	def destroy(self):
		return self.window.destroy()

	def child(self, name):
		return self.builder.get_object(name)

	def dlg_error(self, text):
		dlg = gtk.MessageDialog(self.window, gtk.DIALOG_MODAL, gtk.MESSAGE_ERROR, \
		                        gtk.BUTTONS_OK, text)
		dlg.run()
		dlg.destroy()

	def dlg_yesnocancel(self, question):
		dlg = gtk.MessageDialog(self.window, gtk.DIALOG_MODAL, gtk.MESSAGE_ERROR, \
		                        gtk.BUTTONS_YES_NO, question)
		dlg.add_button(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
		ans = dlg.run()
		dlg.destroy()
		return ans

	def sensitiveness(self, widgets, status):
		for widget in widgets:
			self.child(widget).set_sensitive(status)
