from gnuplot import Gnuplot
import re
import gtk
import glib
import dialog
import session
import os.path

class Export(dialog.Dialog):
	def __init__(self):
		dialog.Dialog.__init__(self, "export")

		self.window.add_button(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
		self.window.add_button("Export", gtk.RESPONSE_ACCEPT)

		gp = Gnuplot()

		gp.set_terminal("")

		ls = self.child("ls_terminal")
		terms = re.findall("[ ]*(.+?)  (.+)", gp.get_last_event())
		for term in terms:
			ls.append((term[0], "%s - <i>%s</i>" % term))

	def on_cmd_terminal_help_clicked(self, widget, data = None):
		cbo = self.child("cbo_terminal")
		it = cbo.get_active_iter()
		if it:
			term = cbo.get_model().get_value(it, 0)
			gp = Gnuplot()
			text = gp.get_last_event() if gp.help(term) is not None else ""
			label = gtk.Label()
			label.set_markup("<tt>%s</tt>" % glib.markup_escape_text(text).strip())

			sw = gtk.ScrolledWindow()
			sw.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
			sw.set_size_request(512,256)
			sw.add_with_viewport(label)

			dlg = gtk.Dialog("Help for %s" % term, None, gtk.DIALOG_DESTROY_WITH_PARENT, (gtk.STOCK_CLOSE,gtk.RESPONSE_CLOSE))
			dlg.get_content_area().pack_start(sw)
			dlg.connect("response", self.on_dlg_terminal_help_response)
			dlg.show_all()
			dlg.run()

	def on_dlg_terminal_help_response(self, widget, response, data = None):
		widget.destroy()

	def export_current_view(self):
		filename = self.window.get_filename()
		if filename.strip() == "": return None
		cbo = self.child("cbo_terminal")
		it = cbo.get_active_iter()
		if it:
			term = cbo.get_model().get_value(it, 0)
			options = self.child("txt_options").get_text()
			gp = Gnuplot()
			gp.set_terminal("push")
			gp.set_terminal(term, options)
			gp.set_output(filename)
			gp.replot()
			gp.set_output()
			gp.set_terminal("pop")

	def get_output(self):
		filename = self.window.get_filename()
		if filename.strip() == "": return None
		cbo = self.child("cbo_terminal")
		it = cbo.get_active_iter()
		if it:
			term = cbo.get_model().get_value(it, 0)
			options = self.child("txt_options").get_text()
			return (filename, term, options)
