import os
import pty
import select
import tty
import termios

class Ptty:
	def __init__(self, timeout = 0):
		self.timeout = timeout
		
	def close(self):
		self.disconnect()
		os.wait()

	def open(self, exe, name, args = None):		
		try:
			pid, fd = pty.fork()
		
		except OSError:
			print "pty.fork() failed."
			return
		
		if pid == 0: # Child process
			try:
				if args == None:
					os.execlp(exe, name)
				else:
					os.execlp(exe, name, args)
				
			except OSError:
				print "execlp failed."
				return

		# Parent process

		#tty.setraw(fd)
		#tty.setcbreak(fd)
		new = termios.tcgetattr(fd)
		new[3] = new[3] & ~termios.ECHO          # lflags
		termios.tcsetattr(fd, termios.TCSADRAIN, new)
		self.fd = fd
		return fd
		
	def disconnect(self):
		os.close(self.fd)

	def write(self, data):
		poll = select.poll()
		poll.register(self.fd, select.POLLOUT)
		fd = poll.poll(self.timeout)
		if len(fd):
			f = fd[0]
			if f[1] > 0:
				os.write(self.fd, data)
				#termios.tcflush(self.fd, termios.TCIFLUSH)
	
	def read(self, n = 1):
		poll = select.poll()
		poll.register(self.fd, select.POLLIN or select.POLLPRI)
		fd = poll.poll(self.timeout)
		if len(fd):
			f = fd[0]
			if f[1] > 0:
				#tty.tcdrain(self.fd)
				return os.read(self.fd, n)
	
	def readlines(self, n = 1):
		c = self.read()
		string = ""
		while c != None:
			string = string + str(c)
			c = self.read()
		#termios.tcflush(self.fd, termios.TCOFLUSH)
		return string
			
	def set_timeout(self, timeout):
		self.timeout = timeout

