#!/usr/bin/env python

import gnuplot
import pipe
import main
import gtk
import config


if __name__ == "__main__":
	# Attempt to start gnuplot
	gp = gnuplot.Gnuplot()
	gp.start()
	gp.answer() # Flush
	
	# Load start-up configuration
	conf = config.Config()
	conf.load_level()
	if conf.startup_conf_file != 'None':
		try:
			with open(conf.startup_conf_file, 'r') as fp:
				gp.cmd(fp.read())
		except IOError:
			print 'WARNING: Unable to load "%s" at startup. Skipping...' % conf.startup_conf_file
	
	# Start the main loop
	main = main.Main()
	gtk.main()
