import re
from gnuplot import Gnuplot

RESTORE = "restore"

class Range:
	def __init__(self, which = None):
		if which: self.parse(which)
		
	def __repr__(self):
		return "[%s:%s] %sreverse %swriteback" % (self.lower, self.upper, "" if self.is_reverse else "no", "" if self.is_writeback else "no")
		
	def parse(self, which):
		gp = Gnuplot()
		gp.show("%srange" % which)
		data = gp.get_last_event()
		
		matches = re.findall("[[] ?(.+?) ?[:] ?(.+?) ?[]]", data)
		match = matches[-1]
		
		self.is_default = True if len(matches) > 1 else False
		self.upper = float(match[1])
		self.lower = float(match[0])

		self.is_reverse = data.find(" reverse") != -1
		self.is_writeback = data.find(" writeback") != -1
